import { AST_NODE_TYPES as e } from "@typescript-eslint/utils";
import { getAllJSDocTags as t, isIdentifier as r, isJSDocDeprecatedTag as a, isJSDocLinkLike as n, isJSDocMemberName as i, isQualifiedName as o, isShorthandPropertyAssignment as s, TypeFormatFlags as p } from "typescript";
import { getParserServices as c } from "@typescript-eslint/utils/eslint-utils";
import { createRule as d } from "../util/index.js";
function u(e) {
    return "string" == typeof e ? e : e.map((e)=>n(e) && e.name ? function(e) {
            let t = "", a = e;
            for(; a;){
                if (o(a) || i(a)) {
                    t = "" === t ? a.right.text : `${a.right.text}#${t}`, a = a.left;
                    continue;
                }
                if (r(a)) {
                    if ("" === t) return a.text;
                    t = `${a.text}#${t}`, a = void 0;
                    continue;
                }
                break;
            }
            return t;
        }(e.name) : e.text).join("");
}
function f(r, n, i, o, s, c) {
    if (o.type === e.Identifier && (o.parent.type === e.CallExpression || o.parent.type === e.NewExpression) && o.parent.callee === o) {
        let e = n.esTreeNodeToTSNodeMap.get(o.parent), s = i.getResolvedSignature(e);
        if (void 0 === s) return;
        let d = s.getDeclaration();
        if (void 0 === d) return;
        for (let n of t(d, a)){
            if (n.comment) {
                r.report({
                    messageId: "deprecatedSignatureWithReason",
                    node: o,
                    data: {
                        name: c,
                        signature: i.signatureToString(s, e, p.WriteTypeArgumentsOfSignature),
                        reason: u(n.comment)
                    }
                });
                break;
            }
            r.report({
                messageId: "deprecatedSignature",
                node: o,
                data: {
                    name: c,
                    signature: i.signatureToString(s, e, p.WriteTypeArgumentsOfSignature)
                }
            });
        }
        return;
    }
    for (let e of s.getDeclarations() ?? [])for (let n of t(e, a)){
        if (n.comment) {
            r.report({
                messageId: "deprecatedWithReason",
                node: o,
                data: {
                    name: c,
                    reason: u(n.comment)
                }
            });
            return;
        }
        r.report({
            messageId: "deprecated",
            node: o,
            data: {
                name: c
            }
        });
    }
}
export default d({
    name: "deprecation",
    meta: {
        docs: {
            description: "Disallow usage of deprecated APIs",
            requiresTypeChecking: !0
        },
        configurations: {
            recommended: "warn",
            strict: "error"
        },
        messages: {
            deprecated: "'{{name}}' is deprecated.",
            deprecatedWithReason: "'{{name}}' is deprecated: {{reason}}",
            deprecatedSignature: "The signature '{{signature}}' of '{{name}}' is deprecated.",
            deprecatedSignatureWithReason: "The signature '{{signature}}' of '{{name}}' is deprecated: {{reason}}"
        },
        schema: [],
        type: "problem"
    },
    defaultOptions: [],
    create (t) {
        let r = c(t), a = r.program.getTypeChecker();
        return {
            Property (n) {
                let i = r.esTreeNodeToTSNodeMap.get(n);
                if (n.key.type === e.Identifier && s(i)) {
                    let e = a.getTypeAtLocation(i.name).getSymbol();
                    if (void 0 === e) return;
                    f(t, r, a, n, e, n.key.name);
                }
            },
            Identifier (n) {
                if (function(t) {
                    switch(t.parent.type){
                        case e.FunctionDeclaration:
                        case e.TSDeclareFunction:
                        case e.ClassDeclaration:
                        case e.TSInterfaceDeclaration:
                        case e.TSTypeAliasDeclaration:
                        case e.Property:
                            return !0;
                        case e.VariableDeclarator:
                            return t.parent.init !== t;
                        case e.TSPropertySignature:
                        case e.PropertyDefinition:
                            return t.parent.key === t;
                    }
                    return !1;
                }(n)) return;
                let i = r.getSymbolAtLocation(n);
                if (void 0 !== i) try {
                    f(t, r, a, n, i, n.name);
                } catch  {
                    return;
                }
            },
            MemberExpression (n) {
                if (n.property.type === e.PrivateIdentifier) {
                    let e = n.property, i = r.getSymbolAtLocation(e);
                    if (void 0 !== i) try {
                        f(t, r, a, e, i, `#${e.name}`);
                    } catch  {
                        return;
                    }
                }
            }
        };
    }
});

//# sourceMappingURL=deprecation.js.map